#ifndef UTILITY
#define UTILITY

#include <chrono>

//timing
auto start = std::chrono::high_resolution_clock::now();
auto end = std::chrono::high_resolution_clock::now();

std::chrono::duration<double> duration;

void timer_start ()
{
  start = std::chrono::high_resolution_clock::now();
}

double timer ()
{
  end = std::chrono::high_resolution_clock::now();
  duration = end-start;
  return duration.count(); 
}

float round(float val, int divisor)
{
	//std::cout << "In: " << val;
	float result = floor((val*divisor) + 0.5) / divisor;
	//std::cout << ", Out: " << result << std::endl;
	return result;
}

int * color_gradient(double val, double max)
{	
	float progress = val/max;
	float div = (std::abs(progress) * 4);
	int ascending =  (int)((div - (int)div) * 255);
	int descending = 255 - ascending;

	//std::cout << "Ascending: " << ascending << " Input: " << val << "/" << max << ", div: " << (int)div << std::endl; 
 	
	static int c[3];

	int step = (int)div;

	if (step == 0)
	{
		c[0] = 255;  
		c[1] = ascending; 
		c[2] = 0;
	} else if (step == 1)
	{
		c[0] = descending;  
		c[1] = 255; 
		c[2] = 0;
	} else if (step == 2)
	{
		c[0] = 0;  
		c[1] = 255; 
		c[2] = ascending;
	} else if (step == 3)
	{
		c[0] = 0;  
		c[1] = descending; 
		c[2] = 255;
	} else if (step == 4)
	{
		c[0] = ascending;  
        c[1] = 0; 
        c[2] = 255;
	} else {
		c[0] = 255;
        c[1] = 255;
        c[2] = 255;
	}

    return c;
}


int * color_gradient_hot(double val, double max)
{	
	float progress = val/max;
	float div = (std::abs(progress) * 3);
	int ascending =  (int)((div - (int)div) * 255);
	int descending = 255 - ascending;

	//std::cout << "Ascending: " << ascending << " Input: " << val << "/" << max << ", div: " << (int)div << std::endl; 
 	
	static int c[3];

	int step = (int)div;

	if (step == 0)
	{
		c[0] = ascending;  
		c[1] = 0; 
		c[2] = 0;
	} else if (step == 1)
	{
		c[0] = 255;  
		c[1] = ascending; 
		c[2] = 0;
	} else if (step == 2)
	{
		c[0] = 255;  
		c[1] = 255; 
		c[2] = ascending;
	} else {
		c[0] = 255;
        c[1] = 255;
        c[2] = 255;
	}

    return c;
}

#endif